use anyhow::Result;
use ecs::{resources::Resource as ResourceTrait, *};
use itertools::Itertools;
use ui_proc_macro::implement_callbacks;

use crate::prelude::*;

use std::marker::PhantomData;

pub trait SetCallback<T, R, Func, Filter> {
    fn set_callback(&self, func: Func);
}

pub trait SetSelectCallback<T, R, Func, Filter> {
    fn set_select_callback(&self, func: Func);
}

pub trait SetCustomCallback<T, R, Func, Filter> {
    fn set_custom_callback(&self, func: Func);
}

implement_callbacks!(2, 0);
